%                       Jacobi.m
%
%           called ny Example1_25_Fig1_9.m
%
%     outputs the Jacobian matrix at every iteration  - to solve by
%                                                   Newton-raphson method
%____________________________________________________________
function [rjac]=jacobi(x,s1,s2,s3,my,mF,mA)
%
      lamda=2*x(1)/s1;
      rjac(1,1)=mA*s1 + s1*s3*x(3);
      rjac(1,2)=-s2;
      rjac(1,3)=s1*s3*x(1)+s3*my;
       
      rjac(2,1)=2*s2/s1;
      rjac(2,2)=2*s3*x(3)+2*mA;
      rjac(2,3)=2*x(2)*s3;

      rjac(3,1)=-(2/s1)*s3*(s2*x(2)+mF);
      rjac(3,2)=-lamda*s3*s2;
      rjac(3,3)=2*(s3*x(3)+mA)^2+4*x(3)*s3*(s3*x(3)+mA);
%
%
      for i=1:3
      for j=1:3
        xx(i,j)=rjac(i,j);
      end
      end
%
      a1=xx(2,2)*xx(3,3) - xx(3,2)*xx(2,3);
      a2=xx(2,1)*xx(3,3) - xx(3,1)*xx(2,3);
      a3=xx(2,1)*xx(3,2) - xx(3,1)*xx(2,2);
      d=xx(1,1)*a1-xx(1,2)*a2+xx(1,3)*a3;
%
      b1=xx(1,2)*xx(3,3) - xx(3,2)*xx(1,3);
      b2=xx(1,1)*xx(3,3) - xx(3,1)*xx(1,3);
      b3=xx(1,1)*xx(3,2) - xx(3,1)*xx(1,2);
%
      c1=xx(1,2)*xx(2,3) - xx(2,2)*xx(1,3);
      c2=xx(1,1)*xx(2,3) - xx(2,1)*xx(1,3);
      c3=xx(1,1)*xx(2,2) - xx(2,1)*xx(1,2);
%
      xx(1,1)=a1/d;
      xx(1,2)=-b1/d;
      xx(1,3)=c1/d;
      xx(2,1)=-a2/d;
      xx(2,2)=b2/d;
      xx(2,3)=-c2/d;
      xx(3,1)=a3/d;
      xx(3,2)=-b3/d;
      xx(3,3)=c3/d;
%
       for i=1:3
       for j=1:3
        sum=0.0;
       for k=1:3
        sum = sum + rjac(i,k)*xx(k,j);
       end
%
       end
       end
      for i=1:3
       for j=1:3
        rjac(i,j)=xx(i,j);   % invertion of Jacobi matrix
       end
      end
%      
end


      