%                   ENKF_blend_egt_opt.m
%
%               called by Fig10_6and10_7.m
%
%               calls gain_matrix.m
%__________________________________________________________________________
function [x2] = ENKF_blend_egt_opt(x1,Np,D,weights,r1_st,r2_st,r3_st,CR2,cr_sp)

CR1 = 0.1;
% 
%--------------------------------------------------------------------------
FREQ(1)=1000;
FREQ(2)=2000;
Ref_sp=repmat(FREQ',1,Np);
%--------------------------------------------------------------------------
h0 = (x1(:,r2_st) - x1(:,r3_st));
h1 = (cr_sp(1,r2_st)-Ref_sp(1,r3_st));
h2 = (Ref_sp(2,r3_st)-cr_sp(2,r2_st));
h=[h0;h1;h2];
%--------------------------------------------------------------------------
gain = gain_matrix(x1,h,Np);
% 
innv = gain*h;

for i = 1:Np
    j = randi(D);
    for k = 1:D
        temp = x1(j,r1_st(i)) + innv(j,i);
        if rand < CR1 || (k == D)
%        
              trial(j,1) = temp;
              if(trial(j,1)<0.004 || trial(j,1)>0.05)
                trial(j,1) = x1(j,i);
              end
        elseif rand < CR2
%          
              trial(j,1) = weights(i)*x1(j,i) + (1 - weights(i))*temp;
              if(trial(j,1)<0.004 || trial(j,1)>0.05)
                trial(j,1) = x1(j,i);
              end
%        
        else
            trial(j,1) = x1(j,i);
        end
        
        j = mod(j+1,D);
        if j == 0
            j = D;
        end
    end
    
    x2(:,i) = trial;
    
end