function dxdt=mySDOF4_2(t,q)
%
%  This program is called by rk4Fig4_2.m
%
% _______________________________________________________________________
      pi=3.14159265d0;
      pi2=2*pi;
%
      % input data of SDOF system (Equation 4.115)
      eta=0.02d0;  % damping
      w=10.0d0;    % frequency in rad/sec.
%
%
%     Input data of the external excitation 
      sig=1.0d0;   % strength of the white noise (Equation 4.115)
%     
%
%
% first order ODEs  Equations 4.120 a,b,c 
       c1=w*w;
       c2=2*eta*w;

       dxdt=[2*q(2);-c1*q(1)-c2*q(2)+q(3);-2*c2*q(3)-2*c1*q(2)+sig];

     end

