%                        Fig4_7.m
%
%    Figure 4.7: Plot of the El Centro 1940 earthquake vertical component
%
%__________________________________________________________________________
clc
clear all
close all
M=importdata('elvert.txt');   % This is an ASCII file
                         % containing two columns (time and the acceleration value)
                         %       each of 3000 elements
%
% 
't';
t=M(:,1) ;   % time 0 - 30 secs with dt=0.02 sec.
'f'  ;       % acceleration in 'g' vaues
f=M(:,2);
figure(1)
plot(t,f,'black')  % Figure 4.7