function [f_val1, f_val2]=RSM_beamExsq(X)
%
%
%
 global K1 K2 C1 C2 s
 
 D=10;    % no. of response moments
%     Np=10;  % no. of particles
%     Npar=4;   % no. of parameters   
 
 K1=X(1);
    K2=X(2);
    C1=X(3);
    C2=X(4);
    s=X(5);
    
%     pause
 T=1;   % total time of integration in sec.
      dt=0.001; % time step in sec.  
      t=0:dt:T;   %  time variable
      Nt =numel(t);    
    
    
   y0=zeros(D,1);    
   x=zeros(D,Nt);    % initialization
% 
   x(:,1)=y0;          % zero initial condition 
   
%    
% Time integration by RK method starts
for ijk=1:Nt-1
%     t(ijk)
  dxdt=rk4MDOF(t(ijk),x(:,ijk),dt);
  x(:,ijk+1)=dxdt;
end
%
%  figure(1)   % Plotted results  in Fgure 4.4
%  plot(t,X(1,:),'black'); hold on     % E[X1^2]
%  plot(t,X(3,:),'black'); hold on     % E[X1Y1]
%  plot(t,X(4,:),'black'); hold on     % E[X2^2]
%  plot(t,X(6,:),'black'); hold on     % E[X2Y2]
%  plot(t,X(7,:),'black'); hold on     % E[X1X2]
  
% figure(2)       % Plotted results in  Fgure 4.5
%  plot(t,X(2,:),'black'); hold on    % E[Y1^2]
%  plot(t,X(5,:),'black'); hold on    % E[Y2^2]
%  plot(t,X(8,:),'black'); hold on    % E[Y1Y2]
 %plot(t,X(9,:),'black'); hold on   % E[X1Y2]
 %plot(t,X(10,:),'black'); hold on   % E[X2Y1]
 
 Lamda0=x(1,Nt);
 Lamda2=x(2,Nt);
 f_val1=Lamda0;
 f_val1=Lamda2;
 
end