function [X_mean Y_mean K_EnKF P_err_ana Cov_ana,X_init_l_f,meas_un] =only_one_EnKF(dof,i,X_init_l,hl,f_amp,omeg,N,Mm,sigma_vel,sigma_k,sigma_c,....
                               sig_meas_disp) 
                           f_dof=floor(dof/2);no_particle=N;
                           m1=Mm(1);
                           for j=1:N
                               
                               xi_l(1:4*dof)=X_init_l(:,j);
                               A=unsc_get_A(dof,xi_l,Mm);
                               T_ini=(i-1)*hl;
                               T_f=i*hl;
                               h_inter=T_f-T_ini;
                               
                               ta=0.5*h_inter*(1-1/sqrt(3));
                               tb=0.5*h_inter*(1+1/sqrt(3));
                               
                               TRa=0;TRb=0;
                               TRa=(((expm(A*(h_inter-ta)))*diag([zeros(1,dof) sigma_vel sigma_k sigma_c ])).^2);
                               TRb=(((expm(A*(h_inter-tb)))*diag([zeros(1,dof) sigma_vel sigma_k sigma_c ])).^2);
                               
                               TR= 0.5*h_inter*(TRa+TRb);
                               Randn1=[zeros(1,dof) randn(1,3*dof)];
                               F11=sqrt(TR)*Randn1';
                               
                              Fa=(expm(A*(h_inter-ta)))*[zeros(1,dof) (f_amp/m1)*cos(omeg*(T_ini+ta))*ones(1,dof) zeros(1,2*dof)]' ;
                              Fb=(expm(A*(h_inter-tb)))*[zeros(1,dof) (f_amp/m1)*cos(omeg*(T_ini+tb))*ones(1,dof) zeros(1,2*dof)]' ;
                                
                               Fab= 0.5*h_inter*(Fa+Fb);
                               
                               
                               X_l=(expm(A*(T_f-T_ini)))*xi_l'+Fab+F11;   %% Generating linearized solutions at the above instants
                               X_init_l_f(1:4*dof,j)=X_l;
                               
                           end
                           
                           
    X_mean= mean(X_init_l_f,2);
 
    
    for u=1:no_particle
        Pert_X(:,u)=(1/sqrt(no_particle-1))*( (X_init_l_f(:,u)-X_mean));
        meas_un(:,u)=X_init_l_f(1:dof,u);
    end
    Y_mean=mean(meas_un,2);
    
    for u=1:no_particle;
        Pert_Y(:,u)=(1/sqrt(no_particle-1))*(meas_un(:,u)-Y_mean);
    end
    
    R=diag(sig_meas_disp(1:dof).^2*hl);
    
    D=(Pert_Y)*(Pert_Y)'+R;
    K_EnKF=Pert_X*(Pert_Y)'*inv(D);
    P_err_ana=(Pert_X-K_EnKF*Pert_Y)*Pert_X';
    
    Cov_ana=100*(Pert_Y*Pert_Y'+R);
    
    
    
    