function alfa1=goldensection(z,mean1,mean2,Index)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Determination of Interval of Uncertainty %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
gr=(sqrt(5)+1)/2;
delta=0.0000000000005;
% aa=funct(delta,X,mu1_mean,z_tilda,z,T_ini,T_f,sig_pros,alfa_bar,beta_bar,force_amp,force_freq);
aa=funct(delta,z,mean1,mean2,Index);
delta1=delta+gr*delta;
bb=funct(delta1,z,mean1,mean2,Index);
if bb<aa                                                                               
    delta1=delta1;
    flag=1;
else
    delta1=-delta1;
    flag=2;
    bb=funct(delta1,z,mean1,mean2,Index);
end
q=1;
while aa>bb
    q=q+1;
    aa=bb;
    sum=0;
    for i=1:q+1
        sum=sum+gr^(i-1);
    end
    if flag==1
        delta1=sum*delta;
    else
        delta1=-sum*delta;
    end
    bb=funct(delta1,z,mean1,mean2,Index);
    
end
sum=0;
for ii=1:q+1
    sum=sum+gr^(ii-1);
end
if flag==1
    ul=sum*delta;
else
    ll=-sum*delta;
end
sum=0;
for ii=1:q-1
    sum=sum+gr^(ii-1);
end 
if flag==1
    ll=sum*delta;
else
    ul=-sum*delta;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Reduction of Interval of Uncertainty and finding the optimum point%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while abs(ul-ll)>0.00005
    a=ul-1/gr*abs(ul-ll);
    b=ll+1/gr*abs(ul-ll);
    fa=funct(a,z,mean1,mean2,Index);
    fb=funct(b,z,mean1,mean2,Index);
    if fa<=fb
        ll=ll;
        ul=b;
    else
        ll=a;
        ul=ul;
    end
end
alfa1=(ul+ll)/2;%display(alfa);

    