function [x_out]=dynamics_euler(x_pre,dt,i,r,w,c,k,m,g,cc,kc)
% 
x1_pre=x_pre(1); x2_pre=x_pre(2);

x1_out=x1_pre+x2_pre*dt;
x2_out=x2_pre+1/m*(-c*x2_pre-2*k*x1_pre+r*cos(w*(i-1)*dt))*dt;
if x1_out>=g
    x2_out=x2_out+1/m*(-cc*x2_pre-kc*(x1_out-g))*dt;
    %    
end
x_out=[x1_out;x2_out];
end
