%                               Example8_1_Fig8_2b
%
%                       psi_max by Higher order linearization
%                  
%
%__________________________________________________________________________
clc; clear all; close all
%
%
% Input parameters 
c=5; k=100;alpha=100;sigma=5;ome_ga=1;  
NL=1000;  % no. of time steps
hh=0.01;  % time step
NN=2000;  % No of particles(Ensemble size)
%
%
%
%
 tic;
%
Final_disp1=zeros(10,NL);
Final_vel1=zeros(10,NL);
%
for j=1:NN% loop over the ensemble 
    j      % smaple counter
% 
A=[0 1;-k -c];
X=zeros(2,10);
xi(1)=0.01;
xi(2)=0.01;
displ=zeros(1,NL);
vel=zeros(1,NL);
displ(1)=xi(1);
vel(1)=xi(2);
%
final_X=zeros(3,10);
XX=zeros(3,3);
%
Brow(1)=0;
%
Omega_init=0;
%
%
for l=0:NL-2
%        
        T0=l*hh;
        T=T0+hh;
%
%
ta=0.5*hh*(1-1/sqrt(3));
tb=0.5*hh*(1+1/sqrt(3));
%
 TRa=0;TRb=0;
 TRa=(((expm(A*(hh-ta)))*[0;sigma]).^2);
 TRb=(((expm(A*(hh-tb)))*[0;sigma]).^2);
 TR= 0.5*hh*(TRa+TRb);
  Fa=(expm(A*(hh-ta)))* [0; -alpha*(displ(l+1)+vel(l+1)*(hh-ta))^3];
  Fb=(expm(A*(hh-tb)))* [0; -alpha*(displ(l+1)+vel(l+1)*(hh-tb))^3];
 Fab= 0.5*hh*(Fa+Fb);
Randn1=randn(1);
F11=sqrt(TR)*Randn1;
X=(expm(A*(T-T0)))*xi'+F11+Fab;
%
 Biplus1=randn(1)*sqrt(T-T0);
 Brow(l+2)=Biplus1;
% 
Phi_1(l+2)=(-1/sigma)*alpha*3*X(1)^2*X(2)*Brow(l+2)+(1/sigma)*alpha*Brow(l+2)*3*(xi(1)+xi(2)*(T-T0))^2*xi(2) +(1/2)*(1/sigma^2)*alpha^2*((X(1)^3)-(xi(1)+xi(2)*(T-T0))^3)^2;
%           
xi(1)=X(1);
xi(2)=X(2);
displ(l+2)=X(1);
vel(l+2)=X(2);
% 
end
% 
[YY,kk]=max(Phi_1);
max_phi(j)=YY;
max_phi_t(j)=kk;
[QQ,uu]=min(Phi_1);
min_phi(j)=QQ;
min_phi_t(j)=uu;
max_phi_tilda=max(Phi_1)+abs(min(Phi_1)); 

 
end
%
   figure(1)   % Figure 8.2b 
% 
  scatter(1:length(max_phi),max_phi,'.','black')
% 
 toc;

