%                           Example8_2_Fig8_8.m
%
%
%
%
%
%__________________________________________________________________________ 
clc; clear all; close all
ll=1;
% 
c1=5.0;c2=5.0 ;k1=100;k2=100;k3=100;alpha=100;sigma1=5;sigma2=5;ome_ga=1;
%
NN=10000; % No of particles(Ensemble size)
NL=1000;% Time span
hh=0.01;
P=2;
%
%__________________________________________________________________________
%                   GCLM - Higher order linearization
tic
h=hh;
M=NL; %Time duration
N=NN; %No. of ensembles
%
Displ=zeros(N,P+2);
Vel=zeros(N,P+2);
%
% 
  A=[0 1 0 0; -(k1+k2) -c1 k2 0; 0 0 0 1; k2 0 -(k2+k3) -c2];
% 
X_init=zeros(4,N);
FinalX_disp_tiplus1_one=X_init(1,1);
FinalX_vel_tiplus1_one= X_init(2,1);
FinalX_disp_tiplus1_two=X_init(3,1);
FinalX_vel_tiplus1_two= X_init(4,1);
%
Phi_next=zeros(1,N);
 nn=0;
 Brow=zeros(1,P+2);
 Brow(1)=0;
%
for i=1:M 
    ih=i
   % No of timesteps
    T0=(i-1)*h;
    T=i*h;
   

    for j=1:N

        xi(1)=X_init(1,j);% Initial values of disp and velocity
        xi(2)=X_init(2,j);
        xi(3)=X_init(3,j);
        xi(4)=X_init(4,j);
        
        Phi_1(1)=Phi_next(j);
        
        I=0;
      while (I==0)
        Sol_x=zeros(4,P+2);
        Phi_1=zeros(1,P+2);
        New_Phi=zeros(1,P+2);
      

        Sol_x(1,1)=xi(1);
        Sol_x(2,1)=xi(2);
        Sol_x(3,1)=xi(3);
        Sol_x(4,1)=xi(4);
                T_random=T0+(T-T0)*rand(P,1);
                T_ascend=sort(T_random);
                T_final=cat(1,T0,T_ascend,T);            
%               
        for p=2:P+2% 
%
            T_ini=T_final(p-1);
            T_f=T_final(p);
            h_inter=T_f-T_ini;
            
            ta=0.5*h_inter*(1-1/sqrt(3));
            tb=0.5*h_inter*(1+1/sqrt(3));

             TRa=0;TRb=0;
             TRa=(((expm(A*(h_inter-ta)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
             TRb=(((expm(A*(h_inter-tb)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
             TR= 0.5*h_inter*(TRa+TRb);
             Fa=(expm(A*(h_inter-ta)))* [0; -alpha*(xi(1)+xi(2)*(h_inter-ta))^3;0;0];
             Fb=(expm(A*(h_inter-tb)))* [0; -alpha*(xi(1)+xi(2)*(h_inter-tb))^3;0;0];
             Fab= 0.5*h_inter*(Fa+Fb);
             Randn2dof=[0; randn(1); 0 ;randn(1)];
             F11=sqrt(TR)*Randn2dof;
%     
             X=(expm(A*(T_final(p)-T_final(p-1))))*xi'+F11+Fab;  
%
            Biplus1=randn(1)*sqrt(T_final(p)-T_final(p-1));
            Brow(p)=Biplus1;
            %
            Phi_1(p)=(-1/sigma1)*alpha*3*X(1)^2*X(2)*Brow(p)+(1/sigma1)*alpha*Brow(p)*3*(xi(1)+xi(2)*(T_final(P+2)-T_final(P+1)))^2*xi(2) +(1/2)*(1/sigma1^2)*alpha^2*((X(1)^3)-(xi(1)+xi(2)*(T_final(P+2)-T_final(P+1)))^3)^2;
            xi(1)=X(1);
            xi(2)=X(2);
            xi(3)=X(3);
            xi(4)=X(4);
            Sol_x(1,p)=X(1);
            Sol_x(2,p)=X(2);
            Sol_x(3,p)=X(3);
            Sol_x(4,p)=X(4);
        end
        for ii=1:P+2
            if Phi_1(ii)<0
                New_Phi(ii)=Phi_1(ii);
            else New_Phi(ii)=0;
            end
        end
%
        New_Phi_sort=sort(New_Phi);
        C=abs(New_Phi_sort(1));
        Phi_1=Phi_1+C;
        U=rand(1);
        for jj=2:P+1              %...........taken only the 2 random pts in bet
            for kk=1:100
                W=(1/h)*rand(1);

                if ((Phi_1(jj)<W)||(U>1/factorial(kk)))
                    if mod(kk,2)~=0;
                        if jj<P+1         %...........taken only the 2 random pts in bet
                           %% disp('repeat')
                            NNN=0;
                            break;
                        else I=1;
                            NNN=0;
                            Displ(j,:)=Sol_x(1,:);
                            Vel(j,:)=Sol_x(2,:);
                            X_inter_init1(:,j)=Sol_x(1,P+2);
                            X_inter_init2(:,j)=Sol_x(2,P+2);
                            X_inter_init3(:,j)=Sol_x(3,P+2);
                            X_inter_init4(:,j)=Sol_x(4,P+2);                                                      
%  
                            Weight(j)=exp(((-1/sigma1)*alpha*(Sol_x(1,P+2)^3*Brow(P+2)-Sol_x(1,P+1)^3*Brow(P+1)-((Sol_x(1,P+1)+Sol_x(2,P+1)*(T_final(P+2)-T_final(P+1)))^3*Brow(P+2)-Sol_x(1,P+1)^3*Brow(P+1))))-C*(T_final(P+2)-T_final(P+1)));

                             Brow(1)=Brow(P+2);
                            New_Phi(j)=Phi_1(P+2);
                            Time_dur(j,:)=T_final;
                            %%disp('Accepted');
                            break;
                        end
                    else I=0;NNN=1;
                        %%disp('Not Accepted');
                        break;
                    end
                end
            end
           if NNN~=0 
               break;
           end
        end
      end
    end
% 
X_init_prev=[X_inter_init1; X_inter_init2;X_inter_init3;X_inter_init4];
X_init=X_init_prev(:,resample(Weight));
% 
Phi_next=New_Phi;
 if i<M
 FinalX_disp_tiplus1_one(i+1)=mean(X_init(1,:).^2);
 FinalX_vel_tiplus1_one(i+1)=mean(X_init(2,:).^2);
 FinalX_disp_tiplus1_two(i+1)=mean(X_init(3,:).^2);
 FinalX_vel_tiplus1_two(i+1)=mean(X_init(4,:).^2); 
 end
% 
end
ttt=h:h:M*h;

 figure(ll);
 plot(ttt,FinalX_disp_tiplus1_two,'black');hold on
 figure(10*ll);
 plot(ttt,FinalX_vel_tiplus1_two,'black');hold on 
toc;
% _________________________________________________________________________
%
%
%
%                       GCLM LOWER ORDER LINEARIZATION
%
tic
hl=hh;
M=NL;% Time span
N=NN;%  ensemble size
Pl=P;
Displ_l=zeros(N,Pl+2);
Vel_l=zeros(N,Pl+2);
%
X_init_l=zeros(4,N);
FinalX_disp1_tiplus1_l=mean(X_init_l(1));
FinalX_vel1_tiplus1_l=mean(X_init_l(2));
FinalX_disp2_tiplus1_l=mean(X_init_l(3));
FinalX_vel2_tiplus1_l=mean(X_init_l(4));
Phi_next_l=zeros(1,N);
 nn=0;
 Brow_l=zeros(1,Pl+2);
 Brow_l(1)=0;
% 
for i=1:M 
 %%%%  No of timesteps
    T0_l=(i-1)*hl;
    T_l=i*hl;
   il=i
%
    for j=1:N
%
        xi_l(1)=X_init_l(1,j);% Initial values of disp and velocity
        xi_l(2)=X_init_l(2,j);
        xi_l(3)=X_init_l(3,j);
        xi_l(4)=X_init_l(4,j);
        Phi_1_l(1)=Phi_next_l(j);
%        
        I=0;
      while (I==0)
        Sol_x_l=zeros(4,Pl+2);
        Phi_1_l=zeros(1,Pl+2);
        New_Phi_l=zeros(1,Pl+2);
%    
        Sol_x_l(1,1)=xi_l(1);
        Sol_x_l(2,1)=xi_l(2);
        Sol_x_l(3,1)=xi_l(3);
        Sol_x_l(4,1)=xi_l(4);       
 %       
                T_random_l=T0_l+(T_l-T0_l)*rand(Pl,1);
                T_ascend_l=sort(T_random_l);
                T_final_l=cat(1,T0_l,T_ascend_l,T_l);               
 %             
        for p=2:Pl+2            
% 
            T_ini=T_final_l(p-1);
            T_f=T_final_l(p);
            h_inter=T_f-T_ini;
%            
            ta=0.5*h_inter*(1-1/sqrt(3));
            tb=0.5*h_inter*(1+1/sqrt(3));
%
            TRa=0;TRb=0;
            TRa=(((expm(A*(h_inter-ta)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
            TRb=(((expm(A*(h_inter-tb)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
            TR= 0.5*h_inter*(TRa+TRb);
            Fa=(expm(A*(h_inter-ta)))* [0; -alpha*(xi_l(1))^3;0;0];
            Fb=(expm(A*(h_inter-tb)))* [0; -alpha*(xi_l(1))^3;0;0];
            Fab= 0.5*h_inter*(Fa+Fb);
            Randn2dof=[0; randn(1); 0 ;randn(1)];
            F11=sqrt(TR)*Randn2dof;
            X_l=(expm(A*(T_final_l(p)-T_final_l(p-1))))*xi_l'+F11+Fab;
            
            Biplus1_l=randn(1)*sqrt(T_final_l(p)-T_final_l(p-1));
            Brow_l(p)=Biplus1_l;
            Phi_1_l(p)=(-1/sigma1)*alpha*3*X_l(1)^2*X_l(2)*Brow_l(p) + (1/2)*(1/sigma1^2)*alpha^2*((X_l(1)^3)-(xi_l(1)^3))^2;
            xi_l(1)=X_l(1);
            xi_l(2)=X_l(2);
            xi_l(3)=X_l(3);
            xi_l(4)=X_l(4);
            Sol_x_l(1,p)=X_l(1);
            Sol_x_l(2,p)=X_l(2);
            Sol_x_l(3,p)=X_l(3);
            Sol_x_l(4,p)=X_l(4); 
%          
        end
        for ii=1:Pl+2
            if Phi_1_l(ii)<0
                New_Phi_l(ii)=Phi_1_l(ii);
            else New_Phi_l(ii)=0;
            end
        end
%
        New_Phi_sort_l=sort(New_Phi_l);
        C=abs(New_Phi_sort_l(1));
        Phi_1_l=Phi_1_l+C;
        U_l=rand(1);
        for jj=2:Pl+1           %...........taken only the 2 random pts in bet
            for kk=1:100
                W_l=(1/hl)*rand(1);
%
                if ((Phi_1_l(jj)<W_l)||(U_l>1/factorial(kk)))
                    if mod(kk,2)~=0;
                        if jj<Pl+1      %...........taken only  the 2 random pts in bet
                           % disp('repeat')
                            NNN=0;
                            break;
                        else I=1;
                            NNN=0;
                            Displ_l(j,:)=Sol_x_l(1,:);
                            Vel_l(j,:)=Sol_x_l(2,:);
                            X_inter_init_di1_l(:,j)=Sol_x_l(1,Pl+2);
                            X_inter_init_vel1_l(:,j)=Sol_x_l(2,Pl+2);
                            X_inter_init_di2_l(:,j)=Sol_x_l(3,Pl+2);
                            X_inter_init_vel2_l(:,j)=Sol_x_l(4,Pl+2);
 %                                                     
                            Weight_l(j)=exp(((-1/sigma1)*alpha*(Sol_x_l(1,Pl+2)^3*Brow_l(Pl+2)-Sol_x_l(1,Pl+1)^3*Brow_l(Pl+1)-Sol_x_l(1,Pl+1)^3*(Brow_l(Pl+2)-Brow_l(Pl+1))))-C*(T_final_l(Pl+2)-T_final_l(Pl+1)));
                          %
                             Brow_l(1)=Brow_l(Pl+2);
                            New_Phi_l(j)=Phi_1_l(Pl+2);
                            Time_dur_l(j,:)=T_final_l;
                            %disp('Accepted');
                            break;
                        end
                    else I=0;NNN=1;
                        %disp('Not Accepted');
                        break;
                    end
                end
            end
           if NNN~=0 
               break;
           end
        end
      end
    end
%
X_init_prev_l=[X_inter_init_di1_l; X_inter_init_vel1_l;X_inter_init_di2_l; X_inter_init_vel2_l];
X_init_l=X_init_prev_l(:,resample(Weight_l));
% 
Phi_next_l=New_Phi_l;
 if i<M
 FinalX_disp_tiplus_di1_l(i+1)=mean(X_init_l(1,:).^2);
 FinalX_vel_tiplus_vel1_l(i+1)=mean(X_init_l(2,:).^2);
 FinalX_disp_tiplus_di2_l(i+1)=mean(X_init_l(3,:).^2);
 FinalX_vel_tiplus_vel2_l(i+1)=mean(X_init_l(4,:).^2); 
% 
 end
% 
end
ttt=hl:hl:M*hl;
figure(ll);
 plot(ttt,FinalX_disp_tiplus_di1_l,'--black');hold on
% 
% 
 figure(10*ll);
 plot(ttt, FinalX_vel_tiplus_vel1_l,'--black');hold on 
%
toc;