%           called by chen_states.m
%
%       calls mychen.m
%__________________________________________________________________________
function dxdt=rk4_chen(ti,xi,h)
k1=mychen(ti,xi);
k2=mychen(ti+h/2,xi+h/2*k1);
k3=mychen(ti+h/2,xi+h/2*k2);
k4=mychen(ti+h,xi+h*k1);
dxdt=xi+h/6*(k1+2*k2+2*k3+k4);
end


