% called by vanderpol_states.m
%
% 4th order Runge Kutta algorithm for solving ODE
%__________________________________________________________________________
function dxdt=rk4_vanderpol(ti,xi,h)
k1=myVanderpol(ti,xi);
k2=myVanderpol(ti+h/2,xi+h/2*k1);
k3=myVanderpol(ti+h/2,xi+h/2*k2);
k4=myVanderpol(ti+h,xi+h*k1);
dxdt=xi+h/6*(k1+2*k2+2*k3+k4);
end


