% called by Fig9_4_5a_6ab.m
%
% routines called by this program: rk4_vanderpol.m
%
%                    solution of the vanderpol DE (9.2)
%__________________________________________________________________________

 function [X]=vanderpol_states()
%
%
T=5.0;
dtt=0.01;
nTt=T/dtt+1;
D=2; % no. of states (parameters)
%
tt=linspace(0,T,nTt)'; % time variable vector
%
y0=[1.4; 0];
%
X(:,1)=y0';
for ijk=1:numel(tt)-1
dxdt=rk4_vanderpol(tt(ijk),X(:,ijk),dtt); % 4th Runge Kutta routine
    X(:,ijk+1)=dxdt;
    clear Y tao
end
%
% 
 end
