% called by Fig6_5c_6_6ef_SA_vanderpol.m

% routines called :rk4_vanderpol.m
%-------------------------------------------------------
% solution of the vanderpol DE (6.1)


 function [X]=vanderpol_states()

%

T=5.0;
dtt=0.01;
nTt=T/dtt+1;
D=2;% no. of states (parameters)

tt=linspace(0,T,nTt)'; % time variable vector


y0=[1.4; 0];

X(:,1)=y0';
for ijk=1:numel(tt)-1

dxdt=rk4_vanderpol(tt(ijk),X(:,ijk),dtt);
    X(:,ijk+1)=dxdt;
    clear Y tao
end

% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
 end
