%   called by ENKF_blend_egt_opt.m 
%
%__________________________________________________________________________
function [gain] = gain_matrix(X,H,Np)

R = 1e-10;

X_prt = 1/sqrt(Np - 1)*(X - repmat(mean(X,2),1,Np));
H_prt = 1/sqrt(Np - 1)*(H - repmat(mean(H,2),1,Np));

gain = X_prt*H_prt'/(H_prt*H_prt' + R*eye(size(H_prt,1)));



