%       called by Table10_2_COMBEOandDE.m
%
%        result by DE (Table 9.
%__________________________________________________________________________
function x2 = DE_opt(x1,Np,D)
CR = 0.1;
for i = 1:Np
    r1 = i;
    while r1 == i
        r1 = randi(Np);
    end
    r2 = i;
    while (r2 == r1 || r2 == i)
        r2 = randi(Np);
    end
    r3 = i;
    while (r3 == r1 || r3 == r2 || r3 == i)
        r3 = randi(Np);
    end
    j = randi(D);
    for k = 1:D
        if rand(1) < CR || k == D
            F = 2*rand(1);
            trial(j,1) = x1(j,r1) + F*(x1(j,r2) - x1(j,r3));  % Equations 9.5 and 9.6
        else
            trial(j,1) = x1(j,i);
        end
        
        j = mod(j+1,D);
        if j == 0
            j = D;
        end
    end
%    
    x2(:,i) = trial;
%    
end