function [x2] = ENKF_blend_egt_opt_1(x1,Np,D,weights,r1_st,r2_st,r3_st,CR2,nset)

CR1 = 0.1;
% CR1 = rand;

h = (x1(:,r2_st) - x1(:,r3_st));
gain = gain_matrix(x1,h,Np);
innv = gain*h;

for i = 1:Np
    j = randi(D);
    for k = 1:D
        temp = x1(j,r1_st(i)) + innv(j,i);
        if rand < CR1 || (k == D && nset == 1)
            trial(j,1) = temp;
        elseif rand < CR2
            trial(j,1) = weights(i)*x1(j,i) + (1 - weights(i))*temp;
        else
            trial(j,1) = x1(j,i);
        end
        
        j = mod(j+1,D);
        if j == 0
            j = D;
        end
    end
    
    x2(:,i) = trial;
    
end