%                           Fig3_4.m
%
%                   samples of Brownian bridge
%
%
%__________________________________________________________________________
clc
clear all
close all
%
T=1; N=500; dt=T/N;  % total time, no. of time steps, time step
%
%initialization 
dW=zeros(1,N);   % Brownian increment
W=zeros(1,N);     %Brownian motion
tm=zeros(1,N);  % time variable
%
dW(1)=sqrt(dt)*randn;
W(1)=dW(1);
%
figure(1)
for j=2:N
  dW(j) = sqrt(dt)*randn;
  W(j) = W(j-1) + dW(j);
end
%
for j=2:N
  tm(j)=(j-1)*dt;
  W(j) = W(j) - tm(j)*W(N);
end
%
W(1)=W(1)-tm(1)*W(N);
plot([0:dt:T],[0,W],'black')   % 1st sample
hold
%
%
%
dW(1)=sqrt(dt)*randn;
W(1)=dW(1);
%
for j=2:N
  dW(j) = sqrt(dt)*randn;
  W(j) = W(j-1) + dW(j);
end
%
for j=2:N
  tm(j)=(j-1)*dt;
  W(j) = W(j) - tm(j)*W(N);
end
%
W(1)=W(1)-tm(1)*W(N);
plot([0:dt:T],[0,W],'black')    % 2nd sample
%
%
%
dW(1)=sqrt(dt)*randn;
W(1)=dW(1);
%
for j=2:N
  dW(j) = sqrt(dt)*randn;
  W(j) = W(j-1) + dW(j);
end
%
for j=2:N
  tm(j)=(j-1)*dt;
  W(j) = W(j) - tm(j)*W(N);
end
%
W(1)=W(1)-tm(1)*W(N);
plot([0:dt:T],[0,W],'black')    % 3rd sample



