function [x_out]=dynamics_euler(x_pre,dt,i,r,w,c,k,alpha,m)
% cs=0.6; ks=1350;
x1_pre=x_pre(1); x2_pre=x_pre(2);

x1_out=x1_pre+x2_pre*dt;
x2_out=x2_pre+1/m*(-c*x2_pre-k*x1_pre-alpha*x1_pre^3+r*cos(w*(i-1)*dt))*dt;

x_out=[x1_out;x2_out];
end
