%  run=30
% for runi=1:run
clear all; clc;close all;

gen_max=100;

 byy=4.378*10^7;
                bzz=4.378*10^7;
                cyy=2.627e3;
                czz=2.627e3;
                
x1_ref(1:gen_max+1)=byy;
x2_ref(1:gen_max+1)=bzz;
x3_ref(1:gen_max+1)=cyy;
x4_ref(1:gen_max+1)=czz;

[z]=rotor_states_full_model(byy,bzz,cyy,czz);
Np=30; D=4;
  
% xl=-[10;10;0];xu=[11;30;10];
 xl=[1*1e7;1*1e7;1e3;1e3];xu=[5*1e7;5*1e7;4e3;4e3];
 x1=repmat(xl,1,Np)+diag(xu-xl)*rand(D,Np);
% % % % x1=repmat(xl,1,Np)+(xu-xl)*rand(1,Np);
% % 
 x1_init=x1;
 save x2_init.mat x1_init z
% load x2_init.mat
x1=x1_init;

for i=1:Np
    cost(i)=fun_rotor(z,x1(:,i));
end

min_cost=min(cost);
cost_plot(1)=mean(cost);

x1_plot(1)=mean(x1(1,:));
x2_plot(1)=mean(x1(2,:));
x3_plot(1)=mean(x1(3,:));
x4_plot(1)=mean(x1(4,:));

count=0;CR=1;
theta_max=2;theta_min=0;

tic
while count<gen_max
    count
    %      for i=1:Np
    for  ii=1:Np
        %         r1=ii;
        %         while r1==ii
        r1=randi(Np);
        %         end
        r1_st(ii)=r1;
        r2=ii;
        while (r2==r1 || r2==ii)
            r2=randi(Np);
        end
        r2_st(ii)=r2;
        r3=ii;
        while (r3==r1 || r3==r2 || r3==ii)
            r3=randi(Np);
        end
        r3_st(ii)=r3;
    end
    
    X=x1;X_pr=x1; hh=(x1(:,r2_st)-x1(:,r3_st));
    h=[cost(r1_st)-min_cost; hh];
    h_pr=[cost(r1_st)-min_cost; hh];
%         h=[hh];
%     h_pr=[hh];
     [gain]=new_KS_EnKF_gain_matrix(X,h,h_pr,X_pr,Np);
%       [gain]=gain_matrix(X,h,Np);
%      [gain]=new_KS_EnKF_gain_matrix(X,h,h_pr,X_pr,method,Np);
%     theta=theta_max-(theta_max-theta_min)*(count/gen_max);
    innv = gain*h;
    %-----------------------------14 6 2015
  for i = 1:Np
    j = randi(D);
%     F=theta;
    for k = 1:D
        if rand(1) < CR || k == D
%             trial(j,1) = x1(j,r1_st(i)) - F*innv(j,i);
        trial(j,1) = x1(j,r1_st(i)) - innv(j,i);
        else
            trial(j,1) = x1(j,i);
        end
        
        j = mod(j+1,D);
        if j == 0
            j = D;
        end      
    end
    
     score=fun_rotor(z,trial);
        if score<=cost(i)
            x2(:,i)=trial;
            cost(i)=score;
        else
            x2(:,i)=x1(:,i);
        end
 end
  
%     for i=1:Np
%         %         trial=x1(:,i);
%         if rand(1)<CR
%             F=theta;            
%             trial(:,1)=x1(:,r1_st(i))-(1+F)*gain*h(:,i);
% %             sig_tmp=1e0/count^2;
% %             trial(:,1)=x1(:,r1_st(i))+sig_tmp*randn(D,1)-(1+F)*gain*h(:,i);
%         else
%             trial(:,1)=x1(:,i);
%         end
%         %         min_cost=min(cost);
%         score=fun_rotor(z,trial);
%         if score<=cost(i)
%             x2(:,i)=trial;
%             cost(i)=score;
%         else
%             x2(:,i)=x1(:,i);
%         end
%     end
%--------------------------14 6 2015
    min_cost=min(cost);
    x1=x2;
    count=count+1;
    cost_plot(count+1)=mean(cost);
%     x1_plot(count+1)=mean(x1(1,:));
%     x2_plot(count+1)=mean(x1(2,:));
%     x3_plot(count+1)=mean(x1(3,:));
%     x4_plot(count+1)=mean(x1(4,:));
    
    mx1=mean(x1(1,:))
    mx2=mean(x1(2,:))
    mx3=mean(x1(3,:))
    mx4=mean(x1(4,:))
    x1_plot(count+1)=mx1;
    x2_plot(count+1)=mx2;
    x3_plot(count+1)=mx3;
    x4_plot(count+1)=mx4;
    
    
    mean(cost)
    
       %---------------------------------- 
    
%        if(count==2)     
    figure(9)
% clf
% subplot(121)
plot(count,x1(1,:),'.black','markersize',10),hold on
xlabel('iteration')
ylabel('stiffness - K11')
%        end
    figure(10)
% clf
% subplot(121)
plot(count,x1(2,:),'.black','markersize',10),hold on
xlabel('iteration')
ylabel('stiffness - K22')

figure(11)
% clf
% subplot(121)
plot(count,x1(3,:),'.black','markersize',10),hold on
xlabel('iteration')
ylabel('damping - C11')

figure(12)
% clf
% subplot(121)
plot(count,x1(4,:),'.black','markersize',10),hold on
xlabel('iteration')
ylabel('damping - C22')
    %----------------------------------
    
    
end
toc
x1
cost
iteration=1:(gen_max+1);
figure(1)
plot(iteration,x1_plot,'black'),hold on
plot(iteration,x1_ref,'--black')

figure(2)
plot(iteration,x2_plot,'black'),hold on
plot(iteration,x2_ref,'--black')

figure(3)
plot(iteration,x3_plot,'black'),hold on
plot(iteration,x3_ref,'--black')

figure(4)
plot(iteration,x4_plot,'black'),hold on
plot(iteration,x4_ref,'--black')

figure(5)
plot(iteration,cost_plot,'black')
