% called by:  Fig9_4_5a_6ab.m
%
% routines called by this program : fun_vanderpol.m
%                                   vanderpol_states.m
%
%
%  (given damping (eta) and stiffness (stif) values), 
%       computation of objective function 
%__________________________________________________________________________
%
function [f_val]=fun_vanderpol(z,x)
global eta stif
%
eta = x(1);
stif =  x(2);
%
[X]=vanderpol_states();
D=numel(x);
f_val=0;
for i=1:size(X,2)
    for j=1:D
  f_val=f_val+(z(j,i)-X(j,i))^2;  % objective function
    end
end
%
end
